
Const RED = 0, BLUE = 1, NEUTRAL = 2
Const NORM = 0, CONVERT = 1, LIGHTNING = 2, BIGBOMB = 3, SHOTPLUS = 4, INVULERABILITY = 5, EXTRALIFE = 6
Const MOUSE = 0, ARROWKEYS = 1, NUMBPAD = 2, WSD = 3, NONE= 4
Const TANK = 0, JET = 1, BOMBER = 2

Type bullet
	Field image
	Field x#,y#
	Field destroy
	Field speed
	Field vecx#,vecy#
	Field dmg%
	Field side
End Type 

Type explosion
	Field x#,y#
	Field sizea#
	Field sizeb#
	Field maxsizea#
	Field maxsizeb#
	Field timer#
End Type 

Type powerup
	Field affect 
	Field image
	Field duration
	Field leftonfield
	Field x#,y#
	Field powername$
End Type 

Type player
	Field side
	Field image
	Field invulnerability
	Field human
	Field controllsettings
	Field lives
	Field bulletnum
	Field time 
	Field planethealth
	Field planet
	Field health
	Field x#,y#
	Field ppx#,ppy#
	Field secs%
	Field secs_till_next_unit%
End Type 

Type unit
	Field unittype
	Field health
	Field image
	Field x#,y#
	Field speed#
	Field side
End Type 

Type ball
	Field side
	Field wearoff
	Field x#,y#
	Field vecx#,vecy#
	Field balltype
	Field image
	Field seconds
	Field speed#
End Type 

Type trailtext
	Field mainstring$
	Field x#
	Field y#
	Field colora,colorb,colorc
	Field duration
End Type 

Global players = 1
Global controlls1 = MOUSE
Global controlls2 = WSD
Global timetillnextpowerup = Rand(500,700)
Global color1
Global color2
Global stringy1$ = "Developed By Realm Interactive"
Global stringy2$ = "Programed, Concepted, and Art By Kevin Knight"
Global stringy3$ = "G A M E  O V E R"

Graphics 900,700,16,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()
TFormFilter 0
Global background = LoadImage("gfx\background.png")
Global bluedead = LoadImage("gfx\blueplanet.png")
MaskImage bluedead, 255,0,255
MidHandle bluedead
Global reddead = LoadImage("gfx\redplanet.png")
MaskImage reddead, 255,0,255
MidHandle reddead
Global size#
Global font = LoadFont("OCR A Extended",29,False,False,False)
Global logofont = LoadFont("Castellar",40,False,False,False)
Global menu = False
Global lc = 0
Global logo = LoadImage("gfx\logo.png")
MaskImage logo,0,0,0


Global redtank = LoadImage("gfx\redtank.png")
Global redjet = LoadImage("gfx\redjet.png")
Global redbomb = LoadImage("gfx\redbomb.png")
Global bluetank = LoadImage("gfx\bluetank.png")
Global bluejet = LoadImage("gfx\bluejet.png")
Global bluebomb = LoadImage("gfx\bluebomb.png")
Global p1 = LoadImage("gfx\converterball.png")
Global p2 = LoadImage("gfx\lightningball.png")
Global p3 = LoadImage("gfx\radioactiveball.png")
Global p4 = LoadImage("gfx\shotplus.png")
Global p5 = LoadImage("gfx\shield.png")
Global p6 = LoadImage("gfx\extralife.png")
Global bulletpic = LoadImage("gfx\bullet.png")

While Not lc = 255
Cls

Color 255,255,255
Rect 0,600,900,700,1
SetFont logofont


lc = lc + 1
Color lc,lc,lc
Rect 0,0,ImageWidth(logo),ImageHeight(logo),1
DrawImage logo, 0,0
Text GraphicsWidth()/2 - StringWidth("REALM INTERACTIVE")/2,600,"REALM INTERACTIVE" 





Flip
Wend 

While Not quit = True 

Cls

SetFont font 
DrawImage background,0,0

Color 143,167,120

Text GraphicsWidth()/2 - StringWidth("PLAY")/2, 200, "PLAY"
If MouseX() > GraphicsWidth()/2 - StringWidth("PLAY")/2 And MouseX() < GraphicsWidth()/2 - StringWidth("PLAY")/2 + StringWidth("PLAY")
If MouseY() > 200 And MouseY() < 220
If MouseHit(1)
menu = False 
Game(players,controlls1,controlls2)

EndIf 
EndIf 
EndIf 
Text GraphicsWidth()/2 - StringWidth("OPTIONS")/2, 300, "OPTIONS"
If MouseX() > GraphicsWidth()/2 - StringWidth("OPTIONS")/2 And MouseX() < GraphicsWidth()/2 - StringWidth("OPTIONS")/2 + StringWidth("OPTIONS")
If MouseY() > 300 And MouseY() < 320
If MouseHit(1)
Options()

EndIf 
EndIf 
EndIf 
Text GraphicsWidth()/2 - StringWidth("QUIT")/2, 400, "QUIT"
If MouseX() > GraphicsWidth()/2 - StringWidth("QUIT")/2 And MouseX() < GraphicsWidth()/2 - StringWidth("OUIT")/2 + StringWidth("OUIT")
If MouseY() > 400 And MouseY() < 420
If MouseHit(1)
quit = True

EndIf 
EndIf 
EndIf 
Text GraphicsWidth()/2 - StringWidth("REALM INTERACTIVE 2005")/2, 500, "REALM INTERACTIVE 2005"
Text GraphicsWidth()/2 - StringWidth("GRAPHICS, DESIGN, AND PROGRAMMING BY KEVIN KNIGHT")/2, 550, "GRAPHICS, DESIGN, AND PROGRAMMING BY KEVIN KNIGHT"
Text GraphicsWidth()/2 - StringWidth("www.brothersrealm.com")/2, 650,"www.brothersrealm.com"


Flip
Wend 
End 


Function Options()

While Not back = True
Cls

DrawImage background,0,0

Text GraphicsWidth()/2 - StringWidth("PLAYERS: " + players + "")/2, 200, "PLAYERS: " + players + ""
If MouseX() > GraphicsWidth()/2 - StringWidth("PLAYERS: " + players + "")/2 And MouseX() < GraphicsWidth()/2 - StringWidth("PLAYERS: " + players + "")/2 + StringWidth("PLAYERS: " + players + "")
If MouseY() > 200 And MouseY() < 220
If MouseHit(1)
players = players + 1
If players > 2
players = 0
EndIf 

EndIf 
EndIf 
EndIf 

If players = 1 Or players = 2

Select controlls1
Case 0
string1$ = "Mouse"
Case 1
string1$ = "Arrow Keys"
Case 2
string1$ = "8,5,4,or 6 Number Pad keys"
Case 3
string1$ = "W,S,A, or D keys"
End Select 

Text GraphicsWidth()/2 - StringWidth("P1 CONTROLS: " + string1$ + "")/2, 300, "P1 CONTROLS: " + string1$ + ""

If MouseX() > GraphicsWidth()/2 - StringWidth("P1 CONTROLS: " + string1$ + "")/2 And MouseX() < GraphicsWidth()/2 - StringWidth("P1 CONTROLS: " + string1$ + "")/2 + StringWidth("P1 CONTROLS: " + string1$ + "")
If MouseY() > 300 And MouseY() < 320
If MouseHit(1)
controlls1 = controlls1 + 1
If controlls1 > 3
controlls1 = 0
EndIf 

EndIf 
EndIf 
EndIf 

EndIf 

If players = 2

Select controlls2
Case 0
string2$ = "Mouse"
Case 1
string2$ = "Arrow Keys"
Case 2
string2$ = "8,5, and 2 Number Pad keys"
Case 3
string2$ = "W,S,A,D keys"
End Select 

Text GraphicsWidth()/2 - StringWidth("P2 CONTROLS: " + string2$ + "")/2, 400, "P2 CONTROLS: " + string2$ + ""

If MouseX() > GraphicsWidth()/2 - StringWidth("P1 CONTROLS: " + string2$ + "")/2 And MouseX() < GraphicsWidth()/2 - StringWidth("P1 CONTROLS: " + string2$ + "")/2 + StringWidth("P1 CONTROLS: " + string2$ + "")
If MouseY() > 400 And MouseY() < 420
If MouseHit(1)
controlls2 = controlls2 + 1
If controlls2 > 3
controlls2 = 0
EndIf 

If controlls2 = controlls1
controlls2 = controlls2 + 1
EndIf 

EndIf 
EndIf 
EndIf 

EndIf 

Text GraphicsWidth()/2 - StringWidth("BACK")/2, 500, "BACK"
If MouseX() > GraphicsWidth()/2 - StringWidth("BACK")/2 And MouseX() < GraphicsWidth()/2 - StringWidth("BACK")/2 + StringWidth("BACK")
If MouseY() > 500 And MouseY() < 520
If MouseHit(1)
back = True

EndIf 
EndIf 
EndIf 




Flip
Wend

End Function 
Function Game(players%,p1,p2)

If players% = 2
CreatePlayer(RED,True,p2)
CreatePlayer(BLUE,True,p1)
ElseIf players%  = 1
CreatePlayer(BLUE,True,p1)
createplayer(RED,False,NONE)
EndIf 
If players% = 0
createplayer(RED,False,NONE)
createplayer(BLUE,False,NONE)
EndIf


CreateBall(NEUTRAL,NORM,GraphicsWidth()/2, GraphicsHeight()/2 - 100)

While Not KeyHit(1) Or menu = True 
Cls 

timetillnextpowerup = timetillnextpowerup - 1

If timetillnextpowerup <= 0
CreatePowerUp(Rand(CONVERT,EXTRALIFE),Rand(120,780),Rand(20,580))
timetillnextpowerup = Rand(400,700)
EndIf 

TextTrail()
PowerUps()
Unit()

bullet()
Player()
Explosion()
Ball()



Line GraphicsWidth()/2,0, GraphicsWidth()/2,600



Flip
Wend : DeleteAll()

End Function 


Function CreatePlayer(side%,human,controllsettings)

p.player = New player

p\side = side
p\lives = 5
p\secs = 300
p\human = human
p\controllsettings = controllsettings
p\secs_till_next_unit = Rand(100,400)
p\bulletnum = 1

Select p\side

Case 1

p\image = LoadImage("gfx\blue.png")
MaskImage p\image,255,0,255
ScaleImage p\image, 0.3,0.3
MidHandle p\image
p\health = 100
p\planethealth = 1000
p\x = 800
p\y = 300
p\planet = LoadImage("gfx\blueplanet.png")
MaskImage p\planet,255,0,255
ScaleImage p\planet,1,2
MidHandle p\planet

p\ppx = GraphicsWidth() + ImageWidth(p\planet)/4
p\ppy = GraphicsHeight()/2 - 100

Case 0

p\image = LoadImage("gfx\red.png")
MaskImage p\image,255,0,255
ScaleImage p\image, -0.3,0.3
MidHandle p\image
p\health = 100
p\planethealth = 1000
p\x = 100
p\y = 300
p\planet = LoadImage("gfx\redplanet.png")
MaskImage p\planet,255,0,255
ScaleImage p\planet,1,2
MidHandle p\planet


p\ppx = 0 - ImageWidth(p\planet)/4
p\ppy = GraphicsHeight()/2 - 100
End Select 

End Function 

Function CreateExplosion(x#,y#,maxsizea#,maxsizeb#)

e.explosion = New explosion

e\x = x#
e\y = y#
e\maxsizea = maxsizea#
e\maxsizeb = maxsizeb#
e\sizea = 1
e\sizeb = 1
e\timer = 60

End Function 


Function Explosion()

For e.explosion = Each explosion



If e\sizea =< e\maxsizea
e\sizea = e\sizea + 1
EndIf 
If e\sizeb =< e\maxsizeb
e\sizeb = e\sizeb + 1
EndIf 

e\timer = e\timer - 1

Color e\timer + 195,e\timer + 195, e\timer + 195 

Oval e\x - e\sizea/2, e\y - e\sizeb/2,e\sizea,e\sizeb,1

If e\timer <= 0 And e\sizeb => e\maxsizeb And e\sizea => e\maxsizea
Delete e
EndIf 

Next 

End Function 

Function CreateBall(side,typeof,x#,y#)

b.ball = New ball

b\side = side
b\balltype = typeof
b\x = x#
b\y = y#
b\speed = 7
randangle = Rand(0,359)
b\vecx = Cos(randangle) * b\speed
b\vecy = Sin(randangle) * b\speed
b\image = LoadImage("gfx\ball.png")
MaskImage b\image, 255,0,255
ScaleImage b\image, .05,.05
MidHandle b\image
b\seconds = 300

End Function

Function CreatePowerUp(typeofpower,x#,y#)

p.powerup = New powerup

p\affect = typeofpower
p\duration = Rand(1000,2000)
p\leftonfield = Rand(300,400)
p\x = x#
p\y = y#

Select p\affect
Case 1
p\image = CopyImage(p1);LoadImage("gfx\converterball.png")
p\powername = "Fleet Converter Ball!"
Case 2
p\image = CopyImage(p2);LoadImage("gfx\lightningball.png")
p\powername = "Lighting Fast Ball!"
Case 3
p\image = CopyImage(p3);LoadImage("gfx\radioactiveball.png")
p\powername = "Radioactive Bomb Ball!"
Case 4
p\image = CopyImage(p4);LoadImage("gfx\shotplus.png")
p\powername = "Extra Shot!"
Case 5
p\image = CopyImage(p5);LoadImage("gfx\shield.png")
p\powername = "Invuleriblity!"
Case 6
p\image = CopyImage(p6);LoadImage("gfx\extralife.png")
p\powername = "Extra life!"
End Select 

MaskImage p\image, 255,0,255
ScaleImage p\image,.15,.15
MidHandle p\image


End Function 


Function PowerUps()

For p.powerup = Each powerup

If p <> Null

DrawImage p\image,p\x,p\y

p\leftonfield = p\leftonfield - 1
If p\leftonfield <= 0
FreeImage p\image
Delete p
EndIf 
EndIf 


Next 

End Function 

Function CreateUnit(side,typeofunit)

u.unit = New unit

u\side = side
u\unittype =  typeofunit

Select u\side

Case 0

u\x = 70
u\y = Rand(15,545)

Select u\unittype

Case 0

u\image = CopyImage(redtank);LoadImage("gfx\redtank.png")
u\health = 5
u\speed = 0.1

MaskImage u\image, 255,0,255

ScaleImage u\image,-0.05,.05

MidHandle u\image

Case 1

u\image = CopyImage(redjet);LoadImage("gfx\redjet.png")
u\health = 4
u\speed = 0.3

MaskImage u\image, 255,0,255

ScaleImage u\image,-0.05,.05

MidHandle u\image

Case 2

u\image = CopyImage(redbomb);LoadImage("gfx\redbomb.png")
u\health = 3
u\speed = 0.6

MaskImage u\image, 255,0,255

ScaleImage u\image,-.05,.05

MidHandle u\image



End Select 

Case 1

u\x = 815
u\y = Rand(15,545)

Select u\unittype

Case 0

u\image = CopyImage(bluetank);LoadImage("gfx\bluetank.png")
u\health = 20
u\speed = -0.1

MaskImage u\image, 255,0,255
ScaleImage u\image,.05,.05


MidHandle u\image


Case 1

u\image = CopyImage(bluejet);LoadImage("gfx\bluejet.png")
u\health = 10
u\speed = -0.3

MaskImage u\image, 255,0,255
ScaleImage u\image,.05,.05


MidHandle u\image

Case 2

u\image = CopyImage(bluebomb);LoadImage("gfx\bluebomb.png")
u\health = 15
u\speed = -0.5

MaskImage u\image, 255,0,255
ScaleImage u\image,.05,.05


MidHandle u\image



End Select 


End Select 



End Function 

Function Unit()

For u.unit = Each unit

DrawImage u\image,u\x,u\y

For b.ball = Each ball
time = b\seconds
Next 

If time <= 0

u\x = u\x + u\speed

number = Rand(0,100)
If number = 30
If u\unittype <> BOMBER
If u\side = RED
CreateBullet(u\x + 3,u\y,-6,u\side)
EndIf 
If u\side = BLUE
CreateBullet(u\x - 3,u\y,6,u\side)
EndIf 
EndIf 
EndIf 
 

If u\unittype = BOMBER
For p.player = Each player
If u\side <> p\side
If ImagesCollide(u\image,u\x,u\y,0,p\image,p\x,p\y,0)
p\health = p\health - 20
u\health = u\health - u\health - 20
EndIf 
EndIf 
Next 
EndIf 



If u\health <= 0
CreateExplosion(u\x,u\y,ImageWidth(u\image) - u\health/2, ImageHeight(u\image) - u\health/2)
FreeImage u\image
Delete u
EndIf 

If u <> Null
If u\x <= 0 Or u\x >= 900
FreeImage u\image
Delete u
EndIf 
EndIf 

EndIf 

Next 

End Function 


Function Ball()



For b.ball = Each ball



DrawImage b\image, b\x,b\y

b\seconds = b\seconds - 1
If b\seconds <= 300 And b\seconds > 200
Text b\x - StringWidth("3"),b\y + 20, "3"
EndIf 
If b\seconds <= 200 And b\seconds > 100
Text b\x - StringWidth("2"),b\y + 20, "2"
EndIf
If b\seconds <= 100 And b\seconds > 0
Text b\x - StringWidth("1"),b\y + 20, "1"
EndIf
If b\seconds <= 0 And b\seconds > -100
Text b\x - StringWidth("GO!"),b\y + 20, "GO!"
EndIf


If b\seconds <= 0
b\x = b\x + b\vecx
b\y = b\y + b\vecy

If b\x < 0
b\x = 0 
b\vecx = -b\vecx
EndIf 
If b\x > 900
b\x = 900
b\vecx = -b\vecx
EndIf 
If b\y < 0
b\y = 0
b\vecy = -b\vecy
EndIf 
If b\y > 600
b\y = 600
b\vecy = -b\vecy
EndIf 
If b\balltype <> NORM
b\wearoff = b\wearoff - 1
If b\wearoff <= 0
b\balltype = NORM
b\image = LoadImage("gfx\ball.png")
b\speed = 7
MaskImage b\image, 255,0,255
ScaleImage b\image, .05,.05
MidHandle b\image
EndIf 
EndIf 


EndIf 


For u.unit = Each unit

If u\side <> b\side

Select b\balltype 
Case 0
If ImagesCollide(b\image,b\x,b\y,0,u\image,u\x,u\y,0)
u\health = u\health - 10
EndIf 
Case 1
If ImagesCollide(b\image,b\x,b\y,0,u\image,u\x,u\y,0)

Select u\side

Case 0



Select u\unittype

Case 0

u\image = LoadImage("gfx\bluetank.png")
u\speed = -u\speed
u\side = 1

MaskImage u\image, 255,0,255

ScaleImage u\image,0.05,.05

MidHandle u\image

Case 1

u\image = LoadImage("gfx\bluejet.png")
u\speed = -u\speed
u\side = 1
MaskImage u\image, 255,0,255

ScaleImage u\image,0.05,.05

MidHandle u\image

Case 2

u\image = LoadImage("gfx\bluebomb.png")
u\speed = -u\speed
u\side = 1
MaskImage u\image, 255,0,255

ScaleImage u\image,.05,.05

MidHandle u\image



End Select 

Case 1



Select u\unittype

Case 0

u\image = LoadImage("gfx\redtank.png")
u\speed = -u\speed
u\side = 0
MaskImage u\image, 255,0,255
ScaleImage u\image,-.05,.05


MidHandle u\image


Case 1

u\image = LoadImage("gfx\redjet.png")
u\speed = -u\speed
u\side = 0
MaskImage u\image, 255,0,255
ScaleImage u\image,-.05,.05


MidHandle u\image

Case 2

u\image = LoadImage("gfx\redbomb.png")
u\speed = -u\speed
u\side = 0
MaskImage u\image, 255,0,255
ScaleImage u\image,-.05,.05


MidHandle u\image



End Select 


End Select 


EndIf 
Case 2
If ImagesCollide(b\image,b\x,b\y,0,u\image,u\x,u\y,0)
u\health = u\health - 10
EndIf 
Case 3
If ImagesCollide(b\image,b\x,b\y,0,u\image,u\x,u\y,0)
u\health = u\health - 20
EndIf

End Select 
EndIf 
Next


For p.powerup = Each powerup

If ImagesCollide(b\image,b\x,b\y,0,p\image,p\x,p\y,0)

If p\affect = 1 Or p\affect = 2 Or p\affect = 3
b\balltype = p\affect
Select b\balltype
Case 1
b\image = LoadImage("gfx\converterball.png")
Case 2
b\image = LoadImage("gfx\lightningball.png")
b\speed = 13
Case 3
b\image = LoadImage("gfx\radioactiveball.png")
End Select 
b\wearoff = p\duration
MaskImage b\image, 255,0,255
ScaleImage b\image, .05,.05
MidHandle b\image
Else 
For pp.player = Each player
If b\side = pp\side
Select p\affect 
Case 4
pp\bulletnum = pp\bulletnum + 1
Case 5
pp\invulnerability = True 
Case 6
pp\lives = pp\lives + 1
End Select
pp\time = p\duration
EndIf 
Next
EndIf
powername$ = p\powername
x = p\x
y = p\y
TrailText(powername$,x,y,100)
FreeImage p\image
Delete p 

EndIf 
Next 


 
If b\side = BLUE
Color 0,0,255
EndIf 
If b\side = RED
Color 255,0,0
EndIf 
If b\side  = NEUTRAL
Color 255,255,255
EndIf 



Next 

End Function 


Function TrailText(name$,x#,y#,duration%)

t.trailtext = New trailtext

t\mainstring = name$
t\x = x#
t\y = y#
t\duration = duration%
t\colora = Rand(50,255)
t\colorb = Rand(50,255)
t\colorc = Rand(50,255)

End Function 


Function TextTrail()

For t.trailtext = Each trailtext

t\duration = t\duration - 1

If t\duration <> 0

Color t\colora,t\colorb,t\colorc
If t\x + StringWidth("" + t\mainstring + "") > 900
t\x = 800 - StringWidth("" + t\mainstring + "")
EndIf 
Text t\x,t\y, "" + t\mainstring + ""

t\y = t\y - 0.1

t\colora = Rand(50,255)
t\colorb = Rand(50,255)
t\colorc = Rand(50,255)

Else 

Delete t

EndIf 

Next 

End Function 


Function Player()

For p.player = Each player

If p <> Null
DrawImage p\image, p\x, p\y

For b.ball = Each ball
time = b\seconds
Next  

If time <= 0


If p\side = BLUE


p\secs_till_next_unit = p\secs_till_next_unit - 1

If p\secs_till_next_unit <= 0
CreateUnit(BLUE,Rand(0,2))
p\secs_till_next_unit = Rand(100,400)
EndIf 


If p\controllsettings = MOUSE

If p\y < MouseY()
p\y = p\y + 5
EndIf 
If p\y > MouseY()
p\y = p\y - 5
EndIf 
If MouseHit(1)
Select p\bulletnum
Case 1
CreateBullet(p\x,p\y,6,p\side)
Case 2
CreateBullet(p\x,p\y - 3,6,p\side)
CreateBullet(p\x,p\y + 3,6,p\side)
Case 3
CreateBullet(p\x,p\y - 4,6,p\side)
CreateBullet(p\x,p\y + 4,6,p\side)
CreateBullet(p\x,p\y,-6,p\side)
Case 4
CreateBullet(p\x,p\y - 3,6,p\side)
CreateBullet(p\x,p\y + 3,6,p\side)
CreateBullet(p\x,p\y - 7,6,p\side)
CreateBullet(p\x,p\y + 7,6,p\side)
End Select 
EndIf
 
EndIf

If p\controllsettings = ARROWKEYS
If KeyDown(200)
p\y = p\y - 5
EndIf 
If KeyDown(208)
p\y = p\y + 5
EndIf 
If KeyHit(203) Or KeyHit(205)
Select p\bulletnum
Case 1
CreateBullet(p\x,p\y,6,p\side)
Case 2
CreateBullet(p\x,p\y - 3,6,p\side)
CreateBullet(p\x,p\y + 3,6,p\side)
Case 3
CreateBullet(p\x,p\y - 4,6,p\side)
CreateBullet(p\x,p\y + 4,6,p\side)
CreateBullet(p\x,p\y,-6,p\side)
Case 4
CreateBullet(p\x,p\y - 3,6,p\side)
CreateBullet(p\x,p\y + 3,6,p\side)
CreateBullet(p\x,p\y - 7,6,p\side)
CreateBullet(p\x,p\y + 7,6,p\side)
End Select EndIf 

EndIf 

If p\controllsettings = NUMBPAD

If KeyDown(72)
p\y = p\y - 5
EndIf 
If KeyDown(76)
p\y = p\y + 5
EndIf 
If KeyHit(77) Or KeyHit(75)
Select p\bulletnum
Case 1
CreateBullet(p\x,p\y,6,p\side)
Case 2
CreateBullet(p\x,p\y - 3,6,p\side)
CreateBullet(p\x,p\y + 3,6,p\side)
Case 3
CreateBullet(p\x,p\y - 4,6,p\side)
CreateBullet(p\x,p\y + 4,6,p\side)
CreateBullet(p\x,p\y,-6,p\side)
Case 4
CreateBullet(p\x,p\y - 3,6,p\side)
CreateBullet(p\x,p\y + 3,6,p\side)
CreateBullet(p\x,p\y - 7,6,p\side)
CreateBullet(p\x,p\y + 7,6,p\side)
End Select  
EndIf 

EndIf 

If p\controllsettings = WSD

If KeyDown(17)
p\y = p\y - 5
EndIf 
If KeyDown(31)
p\y = p\y + 5
EndIf 
If KeyHit(32) Or KeyHit(30)
Select p\bulletnum
Case 1
CreateBullet(p\x,p\y,6,p\side)
Case 2
CreateBullet(p\x,p\y - 3,6,p\side)
CreateBullet(p\x,p\y + 3,6,p\side)
Case 3
CreateBullet(p\x,p\y - 4,6,p\side)
CreateBullet(p\x,p\y + 4,6,p\side)
CreateBullet(p\x,p\y,-6,p\side)
Case 4
CreateBullet(p\x,p\y - 3,6,p\side)
CreateBullet(p\x,p\y + 3,6,p\side)
CreateBullet(p\x,p\y - 7,6,p\side)
CreateBullet(p\x,p\y + 7,6,p\side)
End Select 
EndIf 

EndIf 


If p\controllsettings = NONE


For b.ball = Each ball
If b\x < p\x
If b\y > p\y
p\y = p\y + 5
EndIf 
If b\y < p\y
p\y = p\y - 5
EndIf 
ElseIf b\x > p\x
If b\y > p\y
p\y = p\y - 5
EndIf 
If b\y < p\y
p\y = p\y + 5
EndIf 
EndIf 
Next 

For other.player = Each player

If other <> p
If p\y < other\y + 10 And p\y > other\y - 10
numb = Rand(0,20)
If numb = 15
Select p\bulletnum
Case 1
CreateBullet(p\x,p\y,6,p\side)
Case 2
CreateBullet(p\x,p\y - 3,6,p\side)
CreateBullet(p\x,p\y + 3,6,p\side)
Case 3
CreateBullet(p\x,p\y - 4,6,p\side)
CreateBullet(p\x,p\y + 4,6,p\side)
CreateBullet(p\x,p\y,-6,p\side)
Case 4
CreateBullet(p\x,p\y - 3,6,p\side)
CreateBullet(p\x,p\y + 3,6,p\side)
CreateBullet(p\x,p\y - 7,6,p\side)
CreateBullet(p\x,p\y + 7,6,p\side)
End Select 
Else
EndIf 
EndIf
EndIf 
Next 

EndIf 


EndIf 


If p\side = RED

p\secs_till_next_unit = p\secs_till_next_unit - 1
If p\secs_till_next_unit <= 0
CreateUnit(RED,Rand(0,2))
p\secs_till_next_unit = Rand(100,400)
EndIf 


If p\controllsettings = MOUSE

If p\y < MouseY()
p\y = p\y + 5
EndIf 
If p\y > MouseY()
p\y = p\y - 5
EndIf

If MouseHit(1)
Select p\bulletnum
Case 1
CreateBullet(p\x,p\y,-6,p\side)
Case 2
CreateBullet(p\x,p\y - 3,-6,p\side)
CreateBullet(p\x,p\y + 3,-6,p\side)
Case 3
CreateBullet(p\x,p\y - 4,-6,p\side)
CreateBullet(p\x,p\y + 4,-6,p\side)
CreateBullet(p\x,p\y,-6,p\side)
Case 4
CreateBullet(p\x,p\y - 3,-6,p\side)
CreateBullet(p\x,p\y + 3,-6,p\side)
CreateBullet(p\x,p\y - 7,-6,p\side)
CreateBullet(p\x,p\y + 7,-6,p\side)
End Select 
EndIf 
EndIf 

If p\controllsettings = ARROWKEYS
If KeyDown(200)
p\y = p\y - 5
EndIf 
If KeyDown(208)
p\y = p\y - 5
EndIf 
If KeyHit(203) Or KeyHit(205)
Select p\bulletnum
Case 1
CreateBullet(p\x,p\y,-6,p\side)
Case 2
CreateBullet(p\x,p\y - 3,-6,p\side)
CreateBullet(p\x,p\y + 3,-6,p\side)
Case 3
CreateBullet(p\x,p\y - 4,-6,p\side)
CreateBullet(p\x,p\y + 4,-6,p\side)
CreateBullet(p\x,p\y,-6,p\side)
Case 4
CreateBullet(p\x,p\y - 3,-6,p\side)
CreateBullet(p\x,p\y + 3,-6,p\side)
CreateBullet(p\x,p\y - 7,-6,p\side)
CreateBullet(p\x,p\y + 7,-6,p\side)
End Select 
EndIf 

EndIf 

If p\controllsettings = NUMBPAD

If KeyDown(72)
p\y = p\y - 5
EndIf 
If KeyDown(80)
p\y = p\y + 5
EndIf 
If KeyHit(76)
Select p\bulletnum
Case 1
CreateBullet(p\x,p\y,-6,p\side)
Case 2
CreateBullet(p\x,p\y - 3,-6,p\side)
CreateBullet(p\x,p\y + 3,-6,p\side)
Case 3
CreateBullet(p\x,p\y - 4,-6,p\side)
CreateBullet(p\x,p\y + 4,-6,p\side)
CreateBullet(p\x,p\y,-6,p\side)
Case 4
CreateBullet(p\x,p\y - 3,-6,p\side)
CreateBullet(p\x,p\y + 3,-6,p\side)
CreateBullet(p\x,p\y - 7,-6,p\side)
CreateBullet(p\x,p\y + 7,-6,p\side)
End Select 
EndIf 

EndIf 

If p\controllsettings = WSD

If KeyDown(17)
p\y = p\y - 5
EndIf 
If KeyDown(31)
p\y = p\y + 5
EndIf 
If KeyHit(32) Or KeyHit(30)
Select p\bulletnum
Case 1
CreateBullet(p\x,p\y,-6,p\side)
Case 2
CreateBullet(p\x,p\y - 3,-6,p\side)
CreateBullet(p\x,p\y + 3,-6,p\side)
Case 3
CreateBullet(p\x,p\y - 4,-6,p\side)
CreateBullet(p\x,p\y + 4,-6,p\side)
CreateBullet(p\x,p\y,-6,p\side)
Case 4
CreateBullet(p\x,p\y - 3,-6,p\side)
CreateBullet(p\x,p\y + 3,-6,p\side)
CreateBullet(p\x,p\y - 7,-6,p\side)
CreateBullet(p\x,p\y + 7,-6,p\side)
End Select
EndIf 

EndIf 

If p\controllsettings = NONE

For b.ball = Each ball
If b\x > p\x
If b\y > p\y
p\y = p\y + 5
EndIf 
If b\y < p\y
p\y = p\y - 5
EndIf 
ElseIf b\x < p\x
If b\y > p\y
p\y = p\y - 5
If b\y < p\y
p\y = p\y + 5
EndIf 
EndIf 
EndIf 
Next

For other.player = Each player

If other <> p
If p\y < other\y + 10 And p\y > other\y - 10
numb = Rand(0,20)
If numb = 15
Select p\bulletnum
Case 1
CreateBullet(p\x,p\y,-6,p\side)
Case 2
CreateBullet(p\x,p\y - 3,-6,p\side)
CreateBullet(p\x,p\y + 3,-6,p\side)
Case 3
CreateBullet(p\x,p\y - 4,-6,p\side)
CreateBullet(p\x,p\y + 4,-6,p\side)
CreateBullet(p\x,p\y,-6,p\side)
Case 4
CreateBullet(p\x,p\y - 3,-6,p\side)
CreateBullet(p\x,p\y + 3,-6,p\side)
CreateBullet(p\x,p\y - 7,-6,p\side)
CreateBullet(p\x,p\y + 7,-6,p\side)
End Select 

Else
EndIf 
EndIf
EndIf 
Next 

EndIf 

EndIf 

Else
p\y = 300
EndIf 

If p\side = BLUE
Color 255,255,255
Rect GraphicsWidth()/2,600,GraphicsWidth(),700,0
Text 480,620, "PLANET: " + p\planethealth + ""
Text 480,650, "PLAYER: " + p\health + ""
Text 750,650, "LIVES: " + p\lives + ""
ElseIf p\side = RED
Color 255,255,255
Rect 0,600,GraphicsWidth()/2,700,0
Text 20,620, "PLANET: " + p\planethealth + ""
Text 20,650, "PLAYER: " + p\health + ""
Text 300,650, "LIVES: " + p\lives + ""
EndIf 

DrawImage p\planet,p\ppx,p\ppy

If p\bulletnum > 4
p\bulletnum = 4
EndIf 

If p\y > 600 - ImageHeight(p\image)/2
p\y = 600 - ImageHeight(p\image)/2
EndIf 
If p\y < 0 + ImageHeight(p\image)/2
p\y = 0 + ImageHeight(p\image)/2
EndIf 


If p\invulnerability = True 
If p\time > 0
p\time = p\time - 1
p\health = 100
If p\time <= 0
p\health = 100
p\time = 0
p\invulnerability = False
EndIf 
EndIf 
EndIf 


If p\lives > 0
If p\health <= 0



 PlayerHeal(p,p\secs)


p\y = -45


EndIf 
Else
p\y = -45
EndIf

For b.ball = Each ball

If ImagesCollide(b\image,b\x,b\y,0,p\image,p\x,p\y,0)

Select p\side
Case 0
newangle = Rand(-80,80)
Case 1
newangle = Rand(100,250)
End Select 
b\vecx = Cos(newangle) * b\speed
b\vecy = Sin(newangle) * b\speed
b\side = p\side

If p\side = BLUE
Color 0,0,255
ElseIf p\side = RED
Color 255,0,0
EndIf 

EndIf 



If p\planethealth > 0
If ImagesCollide(b\image,b\x,b\y,0,p\planet,p\ppx,p\ppy,0)


If Not b\balltype = BIGBOMB
p\planethealth = p\planethealth -  50
CreateExplosion(b\x,b\y,ImageWidth(b\image) + 10, ImageHeight(b\image) + 10)
Else
p\planethealth = p\planethealth -  200
CreateExplosion(b\x,b\y,ImageWidth(b\image) + 20, ImageHeight(b\image) + 20)
EndIf 

FreeImage b\image
Delete b
createBall(NEUTRAL,NORM,GraphicsWidth()/2, GraphicsHeight()/2 - 100)
EndIf 

Else
GAMEOVER(p\side)
EndIf  

Next 

 



EndIf 


Next

End Function


Function PlayerHeal(p.player,secs%)



If p <> Null

If p\secs = 300
CreateExplosion(p\x,p\y,ImageWidth(p\image)/2, ImageHeight(p\image)/2)
EndIf 

p\secs = p\secs - 1
Select p\side
Case 0
Text 300,620, "" + p\secs + ""
Case 1
Text 750,620, ""+ p\secs + ""
End Select 
If p\secs <= 0


p\health = 100
p\lives = p\lives - 1
p\y = GraphicsHeight()/2
p\secs = 300
EndIf
Else

EndIf 
End Function 



Function CreateBullet(x#,y#,speed#,side)

b.bullet = New bullet

b\image = CopyImage(bulletpic);LoadImage("gfx\bullet.png")
MaskImage b\image, 255,0,255
ScaleImage b\image,.1,.1
MidHandle b\image

b\x = x#
b\speed = speed#
b\y = y#
b\dmg = 1
b\side = side


End Function 

Function Bullet()

For b.bullet = Each bullet

If b <> Null
DrawImage b\image, b\x,b\y

b\x = b\x - b\speed


For p.player = Each player
If p <> Null
If ImagesCollide(b\image,b\x,b\y,0,p\image,p\x,p\y,0)
If p\side <> b\side
p\health = p\health - b\dmg 
b\destroy = True
EndIf  
EndIf 
EndIf 

Next

For u.unit = Each unit
If u <> Null
If ImagesCollide(b\image,b\x,b\y,0,u\image,u\x,u\y,0)
If u\side <> b\side
u\health = u\health - b\dmg
b\destroy = True
EndIf 
EndIf
EndIf 
 
Next 
For o.ball = Each ball
If o <> Null
If ImagesCollide(b\image,b\x,b\y,0,o\image,o\x,o\y,0)
newangle = Rand(0,359)
o\vecx = Cos(newangle) * o\speed
o\vecy = Sin(newangle) * o\speed
b\destroy = True
EndIf 
EndIf 
Next 


If b\x <= 0 Or b\x >= 900
FreeImage b\image
Delete b
EndIf

EndIf 

If b <> Null
If b\destroy = True
FreeImage b\image
Delete b
EndIf
EndIf  



Next 

End Function 


Function GAMEOVER(side, time = 1200)

While Not time = 0
Cls
time = time - 1

If side = BLUE

DrawImage bluedead,GraphicsWidth()/2,GraphicsHeight()/2

ElseIf side = RED

DrawImage reddead,GraphicsWidth()/2,GraphicsHeight()/2


EndIf 

Color 255,255,255
Oval GraphicsWidth()/2 - size/2,GraphicsHeight()/2 - size/2,size,size

size = size + 5

If time <= 900
If side = RED
Color  0,0,255
Text GraphicsWidth()/2 - StringWidth("BLUE WINS")/2,GraphicsHeight()/2, "BLUE WINS"
EndIf 
If side = BLUE
Color 255,0,0
Text GraphicsWidth()/2 - StringWidth("RED WINS")/2,GraphicsHeight()/2, "RED WINS"
EndIf 


EndIf 

If time <= 700

Color color1,color1,color1
Text GraphicsWidth()/2 - StringWidth("" + stringy1$ + "")/2,GraphicsHeight()/2 + 100, "" + stringy1$ + ""
color1 = color1 + 2
If color1 >= 255
color1 = 255
EndIf 

EndIf 
If time <= 500
Color color2,color2,color2
Text GraphicsWidth()/2 - StringWidth("" + stringy2$ + "")/2,GraphicsHeight()/2 + 200, "" + stringy2$ + ""
color2 = color2 + 2
If color2 >= 255
color2 = 255
EndIf 
EndIf 
If time <= 300
Color 0,0,0
Text GraphicsWidth()/2 - StringWidth("" + stringy3$ + "")/2,GraphicsHeight()/2 + 50, "" + stringy3$ + ""
EndIf 

DeleteAll()





Flip
Wend 
size# = 0
color2 = 0
color1 = 0
menu = True 
End Function 


Function DeleteAll()


For p.player = Each player
FreeImage p\image
FreeImage p\planet
Delete p
Next 

For b.bullet = Each bullet
FreeImage b\image
Delete b
Next 

For bb.ball = Each ball
FreeImage bb\image
Delete bb
Next 

For u.unit = Each unit
FreeImage u\image
Delete u
Next 

For pp.powerup = Each powerup
FreeImage pp\image
Delete pp
Next 

End Function 